#include <stdio.h>
#include <string.h>

#include <windows.h>
#include <winsock.h>

#include <conio.h>

#define KEY_ESC	0x1b

int main (void){

	SOCKET sock21,asock;
	sockaddr_in sock_in21,asock_in;
	WORD wVersionRequested;
	WSADATA wsaData;
	int err, backlog=1, addrlen;
	char send_buff[]="   *SERVER TELNET DI PROVA*\n\r        *RECEIVE ONLY*\n\r*PREMI ESC PER SGANCIARTI*\n\r";
    char recv_buff=' ';

	wVersionRequested = MAKEWORD( 2, 0 ); //winsock ver2.

	printf("MINISERVER TCP/IP listen su porta TELNET\n\n");
	err = WSAStartup( wVersionRequested, &wsaData );
	if ( err != 0 ) {
		printf("Nessuna winsock.dll trovata!\n");
		return(1);
	}
	else printf("Ver$ %d\nHVer$ %d\nMaxSock %d\nMaxUdpDg %d\nDescription: %s\nStatus: %s\n\n",
				wsaData.wVersion,
				wsaData.wHighVersion,
				wsaData.iMaxSockets,
				wsaData.iMaxUdpDg,
                wsaData.szDescription,
                wsaData.szSystemStatus);

	sock21 = socket (PF_INET, SOCK_STREAM, 0);

	if(sock21==INVALID_SOCKET){ printf("Errore socket() ritorna (%d)\n",
								WSAGetLastError());
								return(1);}
	else printf("socket() OK!\n");

	sock_in21.sin_family = PF_INET; //address family
	sock_in21.sin_port = htons (IPPORT_TELNET);	//porta (service) number
	sock_in21.sin_addr.s_addr = INADDR_ANY; // qualsiasi address (locale)

	err = bind (sock21, (struct sockaddr*)&sock_in21, sizeof(struct sockaddr_in));

	if(err==SOCKET_ERROR){printf("Errore bind() ritorna (%d)\n",
									WSAGetLastError());
									return(1);}
	else printf("bind() OK!\n");

	err=listen(sock21, backlog);

	if(err==SOCKET_ERROR){printf("Errore listen() ritorna (%d)\n",
									WSAGetLastError());
									return(1);}
	else printf("listen() OK! Aspetto la connessione..\n");

	//dovrebbe essere del tipo BLOCKING.....
    addrlen=sizeof(struct sockaddr); //<- se non fai cos la accept d WSAFAULT

    asock=accept(sock21, (struct sockaddr*)&asock_in, (LPINT)&addrlen);

	if(asock==INVALID_SOCKET){printf("Errore accept() ritorna (%d)\n",
									WSAGetLastError());
									return(1);}
	else {
		printf("accept() OK!\n");
		printf("sin_port %d\n",ntohs(asock_in.sin_port));
		printf("sin_addr %d.%d.%d.%d\n",asock_in.sin_addr.S_un.S_un_b.s_b1
                                       ,asock_in.sin_addr.S_un.S_un_b.s_b2
                                       ,asock_in.sin_addr.S_un.S_un_b.s_b3
                                       ,asock_in.sin_addr.S_un.S_un_b.s_b4);
		printf("addrlen %d\n",addrlen);
	}

    //invio dati al client.....
	err=send(asock, &send_buff[0], strlen(send_buff), 0);
	if(err==SOCKET_ERROR){printf("Errore send() ritorna (%d)\n",
									WSAGetLastError());
									return(1);}
	else printf("send() OK\n");

    // ricevo dati dal client ed esco se premo ESC
    printf("recv() - aspetto dati dal client..\n");

    while(recv_buff!=KEY_ESC){
     err=recv(asock, &recv_buff, 1, 0); /*un byte alla volta*/
     if(err==SOCKET_ERROR){printf("Errore recv() ritorna (%d)\n",
                                    WSAGetLastError());
	    							return(1);}
     else {
		 if (recv_buff!=KEY_ESC) {
			 printf("%c",recv_buff);        //echo locale
			 send(asock, &recv_buff, 1, 0); //echo remoto
			 // un p presuntuoso senza error checking....
			}

          }
    }

    printf("\n");

	shutdown(asock, 2);
	err=closesocket(asock);
	if(err==SOCKET_ERROR){printf("Errore closesocket(asock) ritorna (%d)\n",
									WSAGetLastError());
									return(1);}
	else printf("closesocket(listening) OK\n");

	shutdown(sock21, 2);
	err=closesocket(sock21);
	if(err==SOCKET_ERROR){printf("Errore closesocket(sock21) ritorna (%d)\n",
									WSAGetLastError());
									return(1);}
	else printf("closesocket(acccepted) OK\n");

	return(0);
}

